\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{tabularx}
\usepackage{array}
\usepackage{amsmath}
\usepackage{breqn}
\usepackage{tikz}
\usetikzlibrary{automata,positioning, arrows}
\usepackage{hyperref}
\usepackage{graphicx} 
\usepackage{float}
\begin{document}
	
\title{CS-445}
\author{Aakarsh Nair}
\date{October 2021}

\title{Programming Assignment -1}
\maketitle
\section*{Experiment 1: Vary number of hidden units}


\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/1-a-regenerated_2021-10-26_07-27-53_PM/1-a-regenerated-plot.png}
	\caption{Experiment with 20 hidden units.}
\end{figure}

\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/1-b-regenerated_2021-10-26_07-29-41_PM/1-b-regenerated-plot.png}
	\caption{Experiment with 50 hidden units.}
\end{figure}

\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/1-c-regenerated_2021-10-26_07-30-24_PM/1-c-regenerated-plot.png}
	\caption{Experiment with 100 hidden units.}
\end{figure}

Do experiments with n = 20, 50, and 100. (Remember to also include a bias unit with
weights to every hidden and output node.) For each value of n.

\begin{enumerate}
	\item How does the number of hidden units affect the final accuracy on the test data?

	There is a notable increase in final accuracy going from 20 hidden units 
	to 100 hidden units. This  is attributed to the model becoming more 
	expressive with the additional weights. 

	\item How does it affect the number of epochs needed for training to converge?
	
	All models converge fairly early with Epoch 1 already reaching close to 90 percent 
	accuracy and then refined all the way to 95 \%. The training set accuracy is always 
	higher than test set pointing to some over-fitting taking place after first 10 epochs.
		
	\item Is there evidence that any of your networks has overfit to the training data? If
	so, what is that evidence?
	
	The network's performance on training data keeps increasing over after the 10th epoch 
	even though there is not a substantial improvement in performance on the test set. This 
	points to the over-fitting taking place beyond the 10th epoch.  
	
	\item  How do your results compare to the result obtained by your perceptron in HW
	1 ?
	
	The highest accuracy for perceptron was in the 85-90 \% we are where as with  100 
	hidden units our accuracy is closer to 95-97 \% range.  Thus the artificial neural 
	network is able to out perform the perceptron model in nearly all configurations.
	
\end{enumerate}


\section*{Experiment 2: Vary the momentum}

\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/2-a-regenerated_2021-10-26_07-31-34_PM/2-a-regenerated-plot.png}
	\caption{Experiment with 0 momentum}
\end{figure}

\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/2-b-regenerated_2021-10-26_07-32-57_PM/2-b-regenerated-plot.png}
	\caption{Experiment with 0.25  momentum}
\end{figure}

\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/2-c-regenerated_2021-10-26_07-33-59_PM/2-c-regenerated-plot.png}
	\caption{Experiment with 0.5 momentum}
\end{figure}


Here, fix the number of hidden units to 100, and vary the 
momentum value during training. Use momentum values of
 0, 0.25, and 0.5.

Train networks using these values as in Experiment 1, 
and plot the results as in

Experiment 1. (Include your plot for n=100 and momentum = 0.9 that you completed in
Experiment 1.)

Create a confusion matrix for each of your trained networks, summarizing results on the test
set. Discuss your results in a paragraph in your report. Include answers to the following
questions:

\begin{enumerate}
	\item  How does the momentum value affect the final accuracy on the test data?
	
		Momentum seems to reduce the accuracy over many epochs, as using zero momentum allows
		the model to train to a fairly high accuracy. However having a sufficiently high momentum seems
		to increase training speed but reduce accuracy.
		
	\item How does it affect the number of epochs needed for training to converge?
	
	
	
	\item Again, is there evidence that any of your networks has overfit to the training
	data? If so, what is that 
	
   The accuracy on the test set consistently lags the accuracy on the training set pointing to 
   the fact that the model may have learned some non-general features of the 
   training set. Peak training set accuracy is 99\% even though the accuracy on the test set
   is never higher than 98\%.
	
\end{enumerate}


\section*{Experiment 3: Vary the number of training examples}


In this experiment,  Fix the number of hidden units to 100 and momentum 0.9. 

Instead of using all of the training examples, 
train two networks, using respectively one quarter and one half of the training
examples for training. Make sure that in each case your
training data is approximately balanced among the 10 
different classes.

Plot the results, as in the previous experiments, plotting accuracy on both 
the training and test data at the end of each epoch.

Create a confusion matrix for each of your trained networks,  
summarizing results on the test set.

Discuss your results in a paragraph in your report. Include answers to the following
questions:

\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/3-a-regenerated_2021-10-26_07-35-27_PM/3-a-regenerated-plot.png}
	\caption{Experiment using quarter of the training set}
\end{figure}

\begin{figure}[H]
	\includegraphics[width=120mm]{../runs/3-b-regenerated_2021-10-26_07-35-51_PM/3-b-regenerated-plot.png}
	\caption{Experiment using half of the training set}
\end{figure}


\begin{enumerate}
	\item How does the size of the training data affect the final accuracy on the test data?
	
	Surprisingly accuracy is not significantly impacted by reducing the size of the training set. Even 
	a network trained on 15 \% is still able to achieve greater than 95\% of the accuracy in 
	first few  epochs.
	
	\item How does it affect the number of epochs needed for training to converge?
	
	The number of epochs needed for convergence seems increase as presumably it has
	fewer data instances to draw conclusions from. 
	
	\item Again, is there evidence that any of your networks has 
	overfit to the training data? If so, what is that evidence?
	
	The overfitting of the data seems to be lesser in these instances. 
	 
	
\end{enumerate}

\end{document}
	